/*
 Wireless Gameboy Controller TX with RX Game Test
 Version: 1.0
 Author: Alex from insideGadgets (http://www.insidegadgets.com)
 Created: 23/09/2018
 Last Modified: 5/11/2018
 
 */
 
#ifndef cbi
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif

#ifndef NULL
#define NULL ((void *)0)
#endif

#define LOW 0
#define HIGH 1
#define false 0
#define true 1

#define LED PB0


// nRF settings (loaded from EEPROM)
uint8_t nrfChannel = 1;
uint8_t nrfTx[5] = "wgbr"; // Last byte loaded from EEPROM
uint8_t nrfPpr = 1;

// EEPROM settings
#define nrfChannelLocation 1
#define nrfTxLocation 2
#define nrfPprLocation 3
#define blankEEPROMByte 255


extern void mirf_init(void);
extern void mirf_config(void);

// SPI transfer 1 byte and return the result
uint8_t spi_transfer(uint8_t data) {
	SPDR = data;
	
	// Wait for transmission complete
	while (!(SPSR & (1<<SPIF)));
	
	return SPDR;
}

// Write data using SPI
void spi_write_data(uint8_t * dataout, uint8_t len) {
	for (uint8_t i = 0; i < len; i++) {
		spi_transfer(dataout[i]);
	}
}

// Read data using SPI
void spi_read_data(uint8_t * datain, uint8_t len) {
	for (uint8_t i = 0; i < len; i++) {
		datain[i] = spi_transfer(0x00);
	}
}

// Initialise the SPI
void spi_init(void) {
	DDRB |= (1<<PB5); // SPI CLK
	DDRB |= (1<<PB3); // SPI DO
	DDRB &= ~(1<<PB4); // SPI DI
	PORTB |= (1<<PB4); // SPI DI
	DDRB |= (1<<PB2); // SPI SS
	
	// Enable SPI, Master, set clock rate / 4
	SPCR = (1<<SPE)|(1<<MSTR);
}

// Setup
void setup(void) {
	_delay_ms(250); // Wait a little bit after power on
	spi_init(); // Initialise SPI
	
	// Load nRF channel and address from EEPROM
	//nrfChannel = eeprom_read_byte((uint8_t*) nrfChannelLocation);
	//nrfTx[4] = eeprom_read_byte((uint8_t*) nrfTxLocation);
	//nrfPpr = eeprom_read_byte((uint8_t*) nrfPprLocation);
	//if (nrfChannel == blankEEPROMByte) {
		//nrfChannel = 1;
		//nrfTx[4] = 1;
		//nrfPpr = 1;
	//}
	
	// mIRF initialise and configure
	mirf_init();
	_delay_ms(50);
	mirf_config();
	
	// Setup outputs
	DDRB |= (1<<LED);
	PORTB |= (1<<LED);
	_delay_ms(50);
	PORTB &= ~(1<<LED);
	
	// Turn on pull-up resistors on other ports to save power
	PORTC |= (1<<PC5);
	
	sei(); // Turn on interrupts
}
